#include "tab.h"
#include "bitmap.h"

class Tab4 : public Tab
{
public:
	Tab4() {}
	virtual ~Tab4(void);

	void create(void);
	void import(void);
	void initTab(void);

	friend BOOL CALLBACK tab4Proc(HWND, UINT, WPARAM, LPARAM);
	friend BOOL CALLBACK copyCharacterProc(HWND, UINT, WPARAM, LPARAM);
	friend UINT CALLBACK tab4ImportProc(HWND, UINT, WPARAM, LPARAM);

private:

	Bitmap spriteBmp;

	BYTE buttonSelected;
	BYTE magnification;
	BYTE xScroll;
	BYTE yScroll;
	BYTE charSelected;
	int spriteSelected;
	BYTE palEntrySelected;
	int copyAll;

	HDC spriteHdc, editHdc;
	HBITMAP spriteBMP, editBMP;

	void addNames(void);
	void brushButton(int, int);
	void changePalEntry(BYTE);
	void changePalette(void);
	void changeTransparency(void);
	void clearImage(void);
	void copyImage(void);
	bool copyImageProc(HWND, UINT, WPARAM, LPARAM);
	void createHDCs(void);
	void createViewImage(void);
	void displayPreview(HWND);
	void drawPaintButtons(WPARAM, LPARAM);
	void drawTab(void);
	void eraseButton(int, int);
	void exportImage(void);
	void flipImage(int);
	void handleMagScroll(int, HWND, int);
	void handleMouseClick(int, int);
	void handleMouseMove(int, int, bool);
	void handleSliders(WPARAM, LPARAM);
	UINT importProc(HWND, UINT, WPARAM, LPARAM);
	void invalidatePics(void);
	void newSelection(void);
	void selectButton(BYTE);
	void setCursor(void);
	void sliderEnable(void);
	void updateControls();
	virtual bool save_internal(char*) override;

	BOOL tabProc(HWND, UINT, WPARAM, LPARAM);
};

BOOL CALLBACK tab4Proc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK copyCharacterProc(HWND, UINT, WPARAM, LPARAM);
UINT CALLBACK tab4ImportProc(HWND, UINT, WPARAM, LPARAM);

extern Tab4 tab4;

